
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>6.23. [U4.65.03] : Operator NUME_DDL_GENE &#8212; Code-Aster v14 0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/app.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="../../_static/code_aster.css" />
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="6.24. [U4.65.04] : Operator ASSE_MATR_GENE" href="u4.65.04.html" />
    <link rel="prev" title="6.22. [U4.65.02] : Operator DEFI_MODELE_GENE" href="u4.65.02.html" />

<script type="text/javascript" src="../../_static/sidebar.js"></script>

<link rel="stylesheet" href="https://use.typekit.net/isi7ftn.css">
<script>try{Typekit.load({ async: true });}catch(e){}</script>
<script type="text/javascript" src="../../_static/copybutton.js"></script>


  </head><body>
<div class="topbar">
  <!--
  <a class="brand" title="Documentation Home" href="../../index.html">
    <span id="logotext">LSST Science Pipelines</span>
  </a>
  -->
  <ul>
    <li><a href="https://www.code-aster.org/V2/spip.php?rubrique19">Code Aster PDF Docs</a></li>
  </ul>
</div>

<div class="related">
    <h3>Navigation</h3>
    <ul>
      <li class="right">
	<a href="u4.65.04.html" title="6.24. [U4.65.04] : Operator ASSE_MATR_GENE">
	  next &raquo;
	</a>
      </li>
      <li class="right">
	<a href="u4.65.02.html" title="6.22. [U4.65.02] : Operator DEFI_MODELE_GENE">
	  &laquo; previous
	</a>
	 |
      </li>
      <li>
	<a href="../../index.html">Code-Aster v14 0.1 documentation</a>
	 &#187;
      </li>
      <li><a href="u4_toc.html" accesskey="U"><span class="section-number">6. </span><strong>U4</strong>: Command documentation</a> &#187;</li>
      
      <li><span class="section-number">6.23. </span><strong>[U4.65.03]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">NUME_DDL_GENE</span></code></li> 
    </ul>
</div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="u4-65-03-operator-nume-ddl-gene">
<span id="u4-65-03"></span><span id="index-0"></span><h1><span class="section-number">6.23. </span><strong>[U4.65.03]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">NUME_DDL_GENE</span></code><a class="headerlink" href="#u4-65-03-operator-nume-ddl-gene" title="Permalink to this headline">¶</a></h1>
<div class="section" id="purpose">
<span id="u4-65-03-1"></span><h2><span class="section-number">6.23.1. </span>Purpose<a class="headerlink" href="#purpose" title="Permalink to this headline">¶</a></h2>
<p>To number the degrees of freedom of the total structure starting from the numbering of the substructures.</p>
<p>For a calculation using the methods of dynamic substructuring (modal or harmonic analysis), the operator
<span class="red">NUME_DDL_GENE</span> defines the bijection between:</p>
<ul class="simple">
<li><p>the number of generalized degrees of freedom of each substructure and the numbers of the interface degrees
of freedom of each connection and,</p></li>
<li><p>the numbers of the final degrees of freedom (i.e. the indices of row or column of generalized matrices).</p></li>
</ul>
<p>After the numbering is carried out, the operator constructs tables for effective storage of the assembled
matrices depending on the “skyline” storage mode. Full or diagonal skyline storage can be used for
a full matrix or to solve a transient modal problem resulting from a concept of the “green:<cite>mode_meca</cite> type.</p>
<p>The output is a data structure of the <span class="green">nume_ddl_gene</span> type.</p>
</div>
<div class="section" id="syntax">
<span id="u4-65-03-2"></span><h2><span class="section-number">6.23.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>nu_gene [nume_ddl_gene] = NUME_DDL_GENE
 (
  # If MODELE_GENE:

  | ◊ MODELE_GENE = mo_gene,                                [modele_gene]
    ◊ STOCKAGE = / &#39;LIGN_CIEL&#39;,                             [DEFAULT]
                 / &#39;PLEIN&#39;,
    ◊ METHODE = / &#39;CLASSIQUE&#39;,                              [DEFAULT]
                / &#39;ELIMINE&#39;,
                / &#39;INITIAL&#39;,

  # If BASE:

  | ◊ BASE = base,                                        / [mode_gene]
                                                          / [mode_meca]
    ◊ STOCKAGE = / &#39;PLEIN&#39;,                                 [DEFAULT]
                 / &#39;DIAG&#39;,
    ◊ NB_VECT = nbvect
 )
</pre></div>
</div>
</div>
<div class="section" id="operands">
<span id="u4-65-03-3"></span><h2><span class="section-number">6.23.3. </span>Operands<a class="headerlink" href="#operands" title="Permalink to this headline">¶</a></h2>
<div class="section" id="operand-model-gene">
<span id="u4-65-03-3-1"></span><h3><span class="section-number">6.23.3.1. </span>Operand <span class="blue">MODEL_GENE</span><a class="headerlink" href="#operand-model-gene" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ MODELE_GENE = mo_gene
</pre></div>
</div>
<p>Name of the concept of the <span class="green">modele_gene</span> type produced by the operator <span class="red">DEFI_MODELE_GENE</span>
<a class="reference internal" href="u4.65.02.html#u4-65-02"><span class="std std-ref">[U4.65.02]</span></a> from which the numbering is carried out.</p>
</div>
<div class="section" id="operand-methode">
<span id="u4-65-03-3-2"></span><h3><span class="section-number">6.23.3.2. </span>Operand <span class="blue">METHODE</span><a class="headerlink" href="#operand-methode" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ METHODE = / &#39;CLASSIQUE&#39;
</pre></div>
</div>
<p>Builds a generalized numbering that takes into account the coupling equations by the method of double
Lagrange multipliers <a class="reference internal" href="../reference/r4.06.02.html#r4-06-02"><span class="std std-ref">[R4.06.02]</span></a>.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ METHODE = / &#39;ELIMINE&#39;
</pre></div>
</div>
<p>Constructs a generalized numbering that takes into account coupling equations by elimination of the
constraints <a class="reference internal" href="../reference/r4.06.02.html#r4-06-02"><span class="std std-ref">[R4.06.02]</span></a>.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ METHODE = / &#39;INITIAL&#39;
</pre></div>
</div>
<p>Initializes the numbering for generalized operators for the construction of a numbering scheme controllable
by Python. Matrices (built with <span class="red">ASSE_MATR_GENE</span>) and vectors (built with <span class="red">ASSE_VECT_GENE</span>) are
of suitable size, but initialized to zero.</p>
</div>
<div class="section" id="storage-of-matrices">
<span id="u4-65-03-3-3"></span><h3><span class="section-number">6.23.3.3. </span>Storage of matrices<a class="headerlink" href="#storage-of-matrices" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ STOCKAGE =
</pre></div>
</div>
<p>Choice of a mode of storage of the matrices which one will assemble with this numbering. Three options are
available:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="s1">&#39;LIGN_CIEL&#39;</span>
</pre></div>
</div>
<p>The <span class="gray">SKY_LINE</span> option indicates block “Skyline” storage: the assembled matrix will be stored as
blocks of columns starting from the first term that is likely to be nonzero for each column.</p>
<p>In the assembled matrix, a term <span class="math notranslate nohighlight">\(A(i,j)\)</span> is likely to be non-zero if and only if the degree of freedom
<span class="math notranslate nohighlight">\(i\)</span> and the degree of freedom <span class="math notranslate nohighlight">\(j\)</span> (the i-th and j-th modes of the total structure) result from
the same substructure or are connected by at least one Lagrange degree of freedom (for two substructures
connected at an interface).</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="s1">&#39;PLEIN&#39;</span>
</pre></div>
</div>
<p>The <span class="gray">FULL</span> option also uses “skyline” storage of the assembled generalized generalized by blocks, but
with a full profile (we store all the elements of the upper triangular matrix). This type of storage must be used
if one wants to calculate full generalized matrices (mass, rigidity, damping), as well as all the generalized
matrices to which they are added.</p>
<p>For the stiffness and damping matrices, the assembly is always done starting from a <span class="green">nume_ddl_gene</span>
resulting from a <span class="green">mode_meca</span>.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">/</span> <span class="s1">&#39;DIAG&#39;</span>
</pre></div>
</div>
<p>In this “skyline” storage option, the diagonal terms of the matrices projected on the modal basis are stored.
This type of storage is to be used when the basis on which one reduces the problem is orthogonal compared to the
matrices used (the mass matrices, stiffness and damping). This storage improves the performance of operators
(<span class="red">DYNA_TRAN_MODAL</span> for example). However, this can lead to incorrect results if the orthogonality is not
satisfied, for example when a basis of modes made up of static modes is used. Indeed, the static modes are not
mutually orthogonal.</p>
</div>
<div class="section" id="operand-base">
<span id="u4-65-03-3-4"></span><h3><span class="section-number">6.23.3.4. </span>Operand <span class="blue">BASE</span><a class="headerlink" href="#operand-base" title="Permalink to this headline">¶</a></h3>
<p>This operand is used to identify the modal basis on which one projects the matrices.</p>
</div>
<div class="section" id="operand-nb-vect">
<span id="u4-65-03-3-5"></span><h3><span class="section-number">6.23.3.5. </span>Operand <span class="blue">NB_VECT</span><a class="headerlink" href="#operand-nb-vect" title="Permalink to this headline">¶</a></h3>
<p>In this keyword, one expects the number of basis projection vectors, possibly smaller than the number of modes
defined in the basis specified by the keyword <span class="blue">BASE</span>. By default, this number is equal to the number of
modes of the basis.</p>
</div>
</div>
<div class="section" id="execution-phase">
<span id="u4-65-03-4"></span><h2><span class="section-number">6.23.4. </span>Execution phase<a class="headerlink" href="#execution-phase" title="Permalink to this headline">¶</a></h2>
<p>No bandwidth optimization is performed during numbering. The order of appearance of the substructures in the
numbering scheme corresponds to the order of their definition in the generalized model (operator
<span class="red">DEFI_MODELE_GENE</span>). The user can therefore limit the bandwidth by defining the substructures of the
generalized model in a judicious order.</p>
<p>The degrees of freedom resulting from double dualisation are then assembled on both sides of the
generalized degrees of freedom of the second assembled substructure (among the two substructures brought
into play by a connection).</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<form action="../../search.html" method="get">
  <input class='c-searchbox' type="text" name="q" placeholder="Search" />
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form><div>
   <h3>Quick search</h3>
   <script async src="https://cse.google.com/cse.js?cx=1913d02e421931d61"></script>
   <div class="gcse-search"></div>
</div><h3>On this page</h3>
<ul>
<li><a class="reference internal" href="#">6.23. <strong>[U4.65.03]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">NUME_DDL_GENE</span></code></a><ul>
<li><a class="reference internal" href="#purpose">6.23.1. Purpose</a></li>
<li><a class="reference internal" href="#syntax">6.23.2. Syntax</a></li>
<li><a class="reference internal" href="#operands">6.23.3. Operands</a><ul>
<li><a class="reference internal" href="#operand-model-gene">6.23.3.1. Operand <span class="blue">MODEL_GENE</span></a></li>
<li><a class="reference internal" href="#operand-methode">6.23.3.2. Operand <span class="blue">METHODE</span></a></li>
<li><a class="reference internal" href="#storage-of-matrices">6.23.3.3. Storage of matrices</a></li>
<li><a class="reference internal" href="#operand-base">6.23.3.4. Operand <span class="blue">BASE</span></a></li>
<li><a class="reference internal" href="#operand-nb-vect">6.23.3.5. Operand <span class="blue">NB_VECT</span></a></li>
</ul>
</li>
<li><a class="reference internal" href="#execution-phase">6.23.4. Execution phase</a></li>
</ul>
</li>
</ul>


        </div>
      </div>
      <div class="clearer"></div>
    </div>
<footer class="footer">
  <p class="pull-right">
    <a href="../../_sources/docs/user/u4.65.03.rst.txt"
       rel="nofollow">Page Source</a> &nbsp;
    <a href="#">Back to Top</a></p>
  <p>
  </p>
  <p>
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 3.5.1. Page design is based on <a href="https://project.lsst.org">LSST</a> created modifications of Astropy's bootstrap-astropy theme in <a href="https://github.com/astropy/astropy-helpers">astropy-helpers</a>. <br />
  </p>
  <p>
    &copy; Copyright 2021, Biswajit Banerjee.  Original version &copy; Copyright 2019 EDF R&amp;D - Licensed under the terms of the GNU FDL (http://www.gnu.org/copyleft/fdl.html).<br/>
  </p>
</footer>
  </body>
</html>